/*
 * cvr_fce.c					verze 1
 *
 * tla funkc pro peklad RTF souboru
 *
 * (c) Pavel RAK, 1996.01.14 19:54 vznik souboru
 *
 * soubor nelze it bez svolen autora
 *
 */

LOCAL void rtf(void)
/******************/
{
	if (rtfz != 1) {		/* otestuj, zda je otevena prvn zvorka, jinak skoni */
		chyba(NENIRTF);		/* rtf mus bt za prvn zvorkou */
	}
}

LOCAL void mac(void)
/******************/
{
	kodovani = MAC;
}

LOCAL void ansi(void)
/*******************/
{
	kodovani = ANSI;
}

LOCAL void pc(void)
/*****************/
{
	kodovani = PC;
}

LOCAL void pca(void)
/******************/
{
	kodovani = PCA;
}

LOCAL void colortbl(void)
/***********************/
{
	preskoc_skupinu();
}

LOCAL void plain(void)
/********************/
{
/*	uloz_text(SLSLOZENA);
	PRIDEJ(UKONCIZAVORKU); */
}

LOCAL void pict(void)
/*******************/
{
	preskoc_skupinu();
}

LOCAL void pard(void)
/*******************/
{
	P_PREAMBULE p_koren = p_spreambule;

	if ((testb == TRUE) && (byl_pard == FALSE)) {
		vypis_fonttbl(p_tabfontu);
		sprintf(sp, "*****************************************************************************");
		PRINT
	}

	if (podcarou == TRUE) {	/* v poznmkch pod arou ignoruj pard */
		return;
	}

	if (parpar == TRUE) {	/* byl-li pedchzejc pkaz par, tak udlej nov
														dek */
		novy_radek();
	}

	if (byl_pard == FALSE) {
		byl_pard = TRUE;				/* vlajka, e ji uloil preambuli a e ji lze
																 normln ukldat znaky */
		while(p_koren != NULL) {
			uloz_text(p_koren->p_text);
			novy_radek();
			p_koren = p_koren->p_dalsi;
		}

		/* uloen rozmru strany */
		/**************************/
		{
			int j = 0;			/* pomocn promnn pro vpoet rozmr */

			/* ka */
			j = TW_MM(sirka - pravy_okraj - levy_okraj);
			sprintf(radek_a, SSIRKA);
			sprintf(radek_b, "%dmm\r", j);
			strcat(radek_a, radek_b);
			uloz_text(radek_a);

			/* vka */
			j = TW_MM(vyska - horni_okraj - dolni_okraj);
			sprintf(radek_a, SVYSKA);
			sprintf(radek_b, "%dmm\r", j);
			strcat(radek_a, radek_b);
			uloz_text(radek_a);

			j = poddsidemargin;
			sprintf(radek_a, SODDSIDEMARGIN);
			sprintf(radek_b, "%dmm\r", j);
			strcat(radek_a, radek_b);
			uloz_text(radek_a);

			j = pevensidemargin;
			sprintf(radek_a, SEVENSIDEMARGIN);
			sprintf(radek_b, "%dmm\r", j);
			strcat(radek_a, radek_b);
			uloz_text(radek_a);

		}

		if (ukladat_font == TRUE) {

			uloz_text(SFONTYJEDNA);
			uloz_text(SFONTYDVE);

			/* uloen definice font z struktury p_tabfontu */
			/*************************************************/
			{
				P_FONTTAB p_koren = p_tabfontu;

				while (p_koren != NULL) {
					sprintf(radek_b, "%s%s", SDEF, FONTPREPINAC);
					uprav_cislovani(radek_b, p_koren->poradi);
					sprintf(radek_a, "{%s} %% %s",
						(p_ssubrf + p_koren->rodina_fontu)->p_textposl, p_koren->p_nazev);
					strcat(radek_b, radek_a);

					if (testf == TRUE) {
						sprintf(sp, "%s", radek_b);
						PRINT
					}

					uloz_text(radek_b);
					novy_radek();
					p_koren = p_koren->p_dalsi;
				}
			}
		}

		uloz_poznamky(SKONECPREAMBULE);
		uloz_text(SBEGINDOCUMENT);
		return;
	}

	if ((tex_skupina != ZADNA) && (p_t_tex_skupina != NULL)) {
		novy_radek();
		uloz_text(p_t_tex_skupina);
		novy_radek();
		tex_skupina = ZADNA;
	}

	if (normalsize == FALSE) {
		/********************************************************************/
		/* neni nejvhodnejsi ukladat normalsize, protoze musim myslet na prvne
				nastavenej font */
		/********************************************************************/
/*		uloz_text("\\normalsize ");*/
		normalsize = TRUE;
	}

}

LOCAL void qr(void)
/*****************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	novy_radek();
	uloz_text(prikaz->p_pred);
	p_t_tex_skupina = prikaz->p_po;
	tex_skupina = FLUSHRIGHT;
	novy_radek();
}

LOCAL void qc(void)
/*****************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	novy_radek();
	uloz_text(prikaz->p_pred);
	p_t_tex_skupina = prikaz->p_po;
	tex_skupina = CENTER;
	novy_radek();
}

LOCAL void ql(void)
/*****************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	novy_radek();
	uloz_text(prikaz->p_pred);
	p_t_tex_skupina = prikaz->p_po;
	tex_skupina = FLUSHLEFT;
	novy_radek();
}

LOCAL void result(void)
/*********************/
{
	preskoc_skupinu();
}

LOCAL void par(void)
/******************/
{
	novy_radek();
}

LOCAL void paperw(void)
/*********************/
{
	sirka = icispar;
}

LOCAL void paperh(void)
/**********************/
{
	vyska = icispar;
}

LOCAL void margl(void)
/********************/
{
	levy_okraj = icispar;
}

LOCAL void margr(void)
/********************/
{
	pravy_okraj = icispar;
}

LOCAL void margt(void)
/********************/
{
	horni_okraj = icispar;
}

LOCAL void margb(void)
/********************/
{
	dolni_okraj = icispar;
}

LOCAL void fnil(void)
/********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = NIL;
	}
}

LOCAL void froman(void)
/*********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = ROMAN;
	}
}

LOCAL void fswiss(void)
/*********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = SWISS;
	}
}

LOCAL void fmodern(void)
/**********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = MODERN;
	}
}

LOCAL void fscript(void)
/**********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = SCRIPT;
	}
}

LOCAL void fdecor(void)
/*********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = DECOR;
	}
}

LOCAL void ftech(void)
/********************/
{
	if (p_akt_font == NULL) {
		TNO("Typ fontu nelze ulozit do NULL tabulky.");
	}
	else {
		p_akt_font->rodina_fontu = TECH;
	}
}

LOCAL void f(void)
/****************/
{

	P_FONT p_koren = p_sfont;	/* zapamatuj si koen struktury fontu ze zdroj */

	if (byl_pard == TRUE) {		/* pi bاnm textu jen pepnej fonty */

		if (ukladat_font == TRUE) {

			if (byla_zavorka == TRUE) {	/* pedchz-li znak { pkazu \f, ulo { */
				PRIDEJ(OBNOVFONT);
				uloz_text(SLSLOZENA);
			}

			if (testf == TRUE) {
				sprintf(sp, "Pepnut fontu: %lu.", lcispar);
				PRINT
			}

			cislo_fontu = lcispar;

			if (cislo_fontu < 0) {	/* \f nen nsledovan kladnm slem */
				sprintf(radek_b, "Poaduje pepnout na nedefinovan font slo `%ld'!", cislo_fontu);
				TNO(radek_b);
				cislo_fontu = default_cislo_fontu;
				return;
			}

			/* generovn sekvence pro pepnut fontu */
			/******************************************/
			{
				P_FONTTAB p_koren = p_tabfontu;

				while (p_koren != NULL) {
					if (p_koren->cislo == cislo_fontu) {
						sprintf(radek_b, "%s", FONTPREPINAC);
						uprav_cislovani(radek_b, p_koren->poradi);
						strcat(radek_b, SMEZERA);

						if (testf == TRUE) {
							sprintf(sp, "%s", radek_b);
							PRINT
						}

						uloz_text(radek_b);
						break;
					}
					p_koren = p_koren->p_dalsi;
				}

				if (p_koren == NULL) {
					sprintf(radek_b, "Poaduje pepnout na nedefinovan font slo `%ld'!", cislo_fontu);
					TNO(radek_b);
					cislo_fontu = default_cislo_fontu;
					return;
				}
				switch (aktualni_rez) {

					case RM:	break;

					case BF:	uloz_text("\\bf ");
										break;

					case IT:	uloz_text("\\it ");
										break;

					default: break;
				}
			}
		}
	}
	else {
		if (byl_fonttbl == TRUE) {
			if (testf == TRUE) {
				sprintf(sp, "Font slo %lu je ji definovn, asi se pouv ve stylu.", lcispar);
				PRINT
			}
		}
		else {
			/* definice fontu v prosted fonttbl */
			P_FONTTAB p_starej = p_akt_font;

			p_akt_font = (P_FONTTAB) nova_pamet(sizeof(FONTTAB));
			p_akt_font->p_nazev = NULL;
			p_akt_font->cislo = 0;
			p_akt_font->rodina_fontu = NIL;
			/* defaultn nastav standardn kdovac	tabulku, u nkterch se
					me zmnit, ale vtinou zstane tato nastaven */
			/************************************************************************/
			/* POZOR! Bude-li se program upravovat pro natn i Windowsovch text,
					je nutn upravit nsledujc piazen. Podle definovan platformy
					(\ansi, \mac) je poteba nastavit DEFAULTN FONTOVOU tabulku pro
					pslun kdovn. Nyn to nastav na prvn uvedenou a je ti jedno,
					zda je aktuln ta i ona platforma. S dalmi fonty je to ji
					vyeeno podmnkou if. */
			/************************************************************************/
			p_akt_font->p_tabulka_znak = p_sfont->tab_znak;

			/* je-li vytven font slo jedna, tak mu nastav slo nula (0) */
			/* jindy sta pist jedniku */

			if (p_tabfontu != NULL) {
				p_akt_font->poradi = p_starej->poradi + 1;
			}
			else {
				p_akt_font->poradi = 0;
			}

			p_akt_font->p_dalsi = NULL;
			p_starej->p_dalsi = p_akt_font;

			if (p_tabfontu == NULL) {	/* nen-li definovn dn font, tak nastav koen na prv vytvoen */
				p_tabfontu = p_akt_font ;
			}

			if (testf == TRUE) {
				sprintf(sp, "Definice fontu slo %lu do tabulky.", lcispar);
				PRINT
			}

			p_akt_font->cislo = lcispar;
			zpracovani();

			{	/* zskn jmna fontu */
				int c;
				int i = 0;

				p_akt_font->p_nazev = (char *) nova_pamet(MAXDELKAFONTU * sizeof(char));

				while (((c = dalsi_znak()) != STREDNIK) && (i < MAXDELKAFONTU)) {
					*(p_akt_font->p_nazev + i++) = c;
					*(p_akt_font->p_nazev + i) = '\0';
					/* putch(c); */
				}
			}

			/* nastaven t sprvn pekdovac tabulky pro font se jmnem */
			/***************************************************************/

			while (p_koren != NULL) {
				if ((strcmp(p_akt_font->p_nazev, p_koren->p_nazev) == 0)
					&& (kodovani == p_koren->kodovani)) {
						p_akt_font->p_tabulka_znak = p_koren->tab_znak;
						break;
				}
				p_koren = p_koren->p_dalsi;
			}

			if (testk == TRUE) {
				{
					char *mody[] = {"poznamky", "text", "mat", "matmat", "nezavisly", "novy radek"};
					int i;

					for (i = 0; i < 256; i++) {
/*						sprintf(sp, "%3d (%c) - %3d (%c)", i, (i < 32 ? 32 : i), p_tabfontu->p_tabulka_znak[i].delka, p_tabfontu->p_tabulka_znak[i].ascii);*/
						if (p_akt_font->p_tabulka_znak[i].delka == 1) {
							sprintf(sp, "%3d (%c) - %3d (%c)", i, (i < 32 ? 32 : i), p_akt_font->p_tabulka_znak[i].delka, p_akt_font->p_tabulka_znak[i].ascii);
						}
						else {
							sprintf(sp, "%3d (%c) -  %s `%s'", i, (i < 32 ? 32 : i), mody[p_akt_font->p_tabulka_znak[i].mod], p_akt_font->p_tabulka_znak[i].p_texposl);
						}
						PRINT
					}
				}
			}

		}
	}
}

LOCAL void fonttbl(void)
/**********************/
{
	PRIDEJ(NASTAVFONTTBL);
}

LOCAL void b(void)
/*****************
 * b me vypadat bu {\b text} nebo \b1 text \b0, proto je nutno oetit
 * ob varianty
 */
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	if ((icispar == 1) || (icispar == -1)) {	/* varianta {\b } a \b1 */
		uloz_text(prikaz->p_pred);
	}
	else {
		uloz_text(prikaz->p_po);
	}
	PRIDEJ(RESETFONTBI);

	if (ukladat_rezy == TRUE) {
		aktualni_rez = BF;
	}

}

LOCAL void i(void)
/*****************
 * i me vypadat bu {\i text} nebo \i1 text \i0, proto je nutno oetit
 * ob varianty
 */
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	if ((icispar == 1) || (icispar == -1)) {	/* varianta {\i } a \i1 */
		uloz_text(prikaz->p_pred);
	}
	else {
		uloz_text(prikaz->p_po);
	}
	PRIDEJ(RESETFONTBI);

	if (ukladat_rezy == TRUE) {
		aktualni_rez = IT;
	}

}

LOCAL void fs(void)
/*****************/
{
	float vyska = (float) icispar/(2*velikostpt);	/* koeficient velikost */
	P_VELFONTU p_koren = p_svelikost;


	if (vykonavat_prikazy == FALSE) {
		return;
	}

	if (ukladat_velikosti == FALSE) {	/* nechce-li velikosti, tak se vra */
		return;
	}

	if (podcarou == TRUE) {	/* je-li v poznmkch pod arou, ignoruj velikosti */
		return;
	}

	normalsize = FALSE;	/* aktuln velikost psma NEN \normalsize */

	while (p_koren != NULL) {
		if (vyska <= p_koren->dolni_mez) {
			uloz_text(SLSLOZENA);
			uloz_text(p_koren->p_texposl);

			switch (aktualni_rez) {
				case RM:	break;
				case BF:	uloz_text("\\bf ");
									break;
				case IT:	uloz_text("\\it ");
									break;
				default: break;
			}

			PRIDEJ(UKONCIZAVORKU);

			if (strcmp(p_koren->p_texposl, "\\normalsize ") == 0) {
				normalsize = TRUE;
			}
			else {
				normalsize = FALSE;
			}

			break;
		}
		else {
			if (p_koren->p_dalsi != NULL) {
				p_koren = p_koren->p_dalsi;
				continue;
			}
			else {	/* kdy poaduje velikost vt ne 2.5, tak ulo Huge */
				uloz_text(p_koren->p_texposl);

					switch (aktualni_rez) {
						case RM:	break;
						case BF:	uloz_text("\\bf ");
											break;
						case IT:	uloz_text("\\it ");
											break;
						default: break;
					}

				break;
			}
		}
	}

	if (ukladat_font == FALSE) {	/* nechci-li ukladat fonty, tak se vrat */
		return;
	}

	/* generovn sekvence pro pepnut fontu */
	/******************************************/
	{
		P_FONTTAB p_koren = p_tabfontu;

		while (p_koren != NULL) {
			if (p_koren->cislo == cislo_fontu) {
				sprintf(radek_b, "%s", FONTPREPINAC);
				uprav_cislovani(radek_b, p_koren->poradi);
				strcat(radek_b, SMEZERA);

				if (testf == TRUE) {
						sprintf(sp, "%s", radek_b);
						PRINT
				}

				uloz_text(radek_b);
				break;
			}
			p_koren = p_koren->p_dalsi;
		}

		if (p_koren == NULL) {
			sprintf(radek_b, "Poaduje pepnout na nedefinovan font slo `%ld'!", cislo_fontu);
			TNO(radek_b);
			cislo_fontu = default_cislo_fontu;
			return;
		}
	}

}

LOCAL void ul(void)
/*****************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void uld(void)
/******************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void uldb(void)
/*******************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void scaps(void)
/********************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void caps(void )
/******************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void ulw(void)
/******************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
}

LOCAL void footnote(void)
/***********************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	podcarou = TRUE;
	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIZAVORKU);
	PRIDEJ(NULUJPOZNAMKY);
}

LOCAL void up(void)
/*****************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIINDEX);
}

LOCAL void dn(void)
/*****************/
{

	return;

	/*	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIINDEX);	*/
}

LOCAL void super(void)
/********************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
	PRIDEJ(UKONCIINDEX);
}

LOCAL void stylesheet(void)
/*************************/
{
	preskoc_skupinu();
}

LOCAL void chdate(void)
/*********************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
}

LOCAL void line(void)
/*******************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
}

LOCAL void page(void)
/********************/
{

	if (vykonavat_prikazy == FALSE) {
		return;
	}

	uloz_text(prikaz->p_pred);
}

LOCAL void deff(void)
/*******************/
{
	default_cislo_fontu = cislo_fontu = lcispar;
}

LOCAL void field(void)
/********************/
{
	preskoc_skupinu();
}

LOCAL void object(void)
/*********************/
{
	objekt = TRUE;
	preskoceni = TRUE;
	PRIDEJ(RESETUJOBJEKTY);
}

LOCAL void objclass(void)
/***********************/
{
	int i = 0;

	preskoceni = FALSE;
	while ((c = dalsi_znak()) != LSLOZENA) {
		radek_b[i++] = c;
	}

	radek_b[--i] = '\0';
	--rtfz;
	vykonej_rzas(p_rzas);
	p_rzas = zrus_rvrchol(p_rzas);

	if (teste == TRUE) {
		sprintf(sp, "Typ objektu: '%s'", radek_b);
		PRINT
	}

	if (strcmp(radek_b, SEQUATION) == 0) {	/* porovnej typ objektu s Equation */
		typ_objektu = EQUATION;
	}

}

LOCAL void objdata(void)
/**********************/
{

	preskoceni = FALSE;

	if (objekt == FALSE) {
		TNO("Nesprvn pouit \\objclass mimo skupinu \\object.");
		preskoc_skupinu();
		return;
	}

	if (typ_objektu != EQUATION) {
		TNO("Souasn verze programu um zpracovvat pouze vzorce Equation.");
		preskoc_skupinu();
		return;
	}

	if (testz == TRUE) {
		if (testf == TRUE) {
			TNO("Zpracovn vzoreku funkc preloz_vzorec().");
		}
		preloz_vzorec();
	}

	preskoc_skupinu();

}

#include "make.c"	/* nataen vygenerenovanch pointer na funkce */

/*************************** konec souboru **********************************/
